{% extends "@admin/layout.twig" %}
{% block head %}
    <title>App | Admin page</title>

    <style>
        tbody tr.selected {
            background-color: #f7f7f7;
        }
        tbody tr.selected:hover {
            background-color: #f3f3f3;
        }
        .uk-notification-message-success{
            background: rgba(50, 210, 150, 0.10) !important;
        }
        .uk-notification-message-danger{
            background: rgba(240, 80, 110, 0.11) !important;
        }
    </style>
{% endblock %}

{% block title %}
    Users
{% endblock %}

{% block alert %}
{% endblock %}

{% block content %}
    <div id="add_user_modal" uk-modal>
        <div class="uk-modal-dialog uk-modal-body">
            <button class="uk-modal-close-outside" type="button" uk-close></button>
            <div class="uk-modal-header">
                <h2 class="uk-modal-title">Add user</h2>
            </div>
            <div class="uk-modal-body">
                <label class="uk-form-label" for="email">Email</label>
                <div class="uk-form-controls">
                    <input class="uk-input" id="email" type="email" placeholder="email@example.com">
                </div>
                <label class="uk-form-label" for="password">Password</label>
                <div class="uk-form-controls">
                    <input class="uk-input" id="password" type="password" placeholder="Password">
                </div>
                <div class="uk-form-controls">
                    <label><input id="active" class="uk-checkbox" type="checkbox" checked> Active</label>
                </div>
                <div class="uk-form-controls">
                    <label><input id="privileged" class="uk-checkbox" type="checkbox"> Admin</label>
                </div>
            </div>
            <div class="uk-modal-footer uk-text-right">
                <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
                <button id="add_user" class="uk-button uk-button-primary" type="button">Save</button>
            </div>
        </div>
    </div>
    <div id="edit_user_modal" uk-modal>
        <div class="uk-modal-dialog uk-modal-body">
            <button class="uk-modal-close-outside" type="button" uk-close></button>
            <div class="uk-modal-header">
                <h2 class="uk-modal-title">Add user</h2>
            </div>
            <div class="uk-modal-body">
                <label class="uk-form-label" for="edit_email">Email</label>
                <div class="uk-form-controls">
                    <input class="uk-input" id="edit_email" type="email" placeholder="email@example.com">
                </div>
                <label class="uk-form-label" for="edit_password">Password</label>
                <div class="uk-form-controls">
                    <input class="uk-input" id="edit_password" type="password" placeholder="Password">
                </div>
                <div class="uk-form-controls">
                    <label><input id="edit_active" class="uk-checkbox" type="checkbox" checked> Active</label>
                </div>
                <div class="uk-form-controls">
                    <label><input id="edit_privileged" class="uk-checkbox" type="checkbox"> Admin</label>
                </div>
            </div>
            <div class="uk-modal-footer uk-text-right">
                <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
                <button id="edit_user" class="uk-button uk-button-primary" type="button">Save</button>
            </div>
        </div>
    </div>

    <div class="uk-flex uk-grid-collapse uk-margin-small uk-flex-center@m" uk-grid>
        <div class="uk-width-1-1 uk-flex uk-margin-small-bottom">
            <div class="uk-width-1-2">
                <button  class="uk-button uk-button-default" uk-toggle="target: #add_user_modal">
                    Add
                </button>
                <button id="delete_row" class="uk-button uk-button-default" disabled>
                    Delete
                </button>
                <button id="edit" class="uk-button uk-button-default" disabled>
                    Edit
                </button>
            </div>
            <div class="uk-width-1-2">
                <form class="uk-search uk-float-right uk-search-default">
                    <span class="uk-search-icon-flip" uk-search-icon></span>
                    <label for="search"></label>
                    <input id="search" class="uk-search-input" type="search" placeholder="Search...">
                </form>
            </div>
        </div>
        <div class="uk-width-1-1@l">
            <table id="users" class="uk-table uk-table-hover ">
                <thead>
                <tr>
                    <th class="uk-width-small">id</th>
                    <th>email</th>
                    <th>privileged</th>
                    <th>active</th>
                    <th>create at</th>
                </tr>
                </thead>
            </table>
        </div>
        <ul class="uk-pagination">
            <li><a id="previous" ><span class="uk-margin-small-right" uk-pagination-previous></span> Previous</a></li>
            <li class="uk-margin-auto-left"><a id="next" >Next <span class="uk-margin-small-left" uk-pagination-next></span></a></li>
        </ul>
    </div>
{#    <div class="uk-notification-message uk-notification-message-success"></div>#}
{% endblock %}



{% block script %}
    <!--suppress JSCheckFunctionSignatures, JSJQueryEfficiency -->
    <script>
        $(document).ready(function() {

            let csrfName = '{{csrf.name}}';
            let csrfValue = '{{csrf.value}}';
            let table = $('#users').DataTable({
                select: {
                    style: 'multi+shift'
                },
                // searching: false,
                lengthChange: false,
                paging:true,
                processing: true,
                serverSide: true,
                // "dom": '<"uk-table uk-table-hover"t><"uk-pagination"p>',
                "dom": '<t><i>',
                ajax: {
                    url: "{{ path_for('admin.api.users.get') }}",
                    type: "GET"
                },
                columns: [
                    { "data": "id" },
                    { "data": "email" },
                    { "data": "privileged" },
                    { "data": "active" },
                    { "data": "create_at" }
                ]
            });
            table.on( 'select', function ( e, dt, type, indexes ) {
                if ( type === 'row' ) {
                    $('#delete_row').prop( "disabled", false );
                }
                if(table.rows( { selected: true } ).count() === 1){
                    // console.log()
                    $('#edit').prop( "disabled", false );
                }else {
                    $('#edit').prop( "disabled", true );
                }
            });
            table.on( 'deselect', function ( e, dt, type, indexes ) {
                if(table.rows( { selected: true } ).count() === 0) {
                    $('#delete_row').prop("disabled", true);
                    $('#edit').prop("disabled", true);
                }
                if(table.rows( { selected: true } ).count() === 1){
                    $('#edit').prop("disabled", false);
                }
            });
            $('#delete_row').on('click', function () {
                $('#delete_row').prop( "disabled", true );
                let rows = table.rows( { selected: true } );
                rows.every( function ( rowIdx, tableLoop, rowLoop ) {
                    let data = this.data();
                    console.log(data);
                    let userId = data.id;
                    $.ajax({
                        type: "DELETE",
                        async: false,
                        url: "{{ path_for('admin.api.users.delete') }}?id=" + userId,
                        data: {
                            '{{csrf.keys.name}}': csrfName,
                            '{{csrf.keys.value}}': csrfValue
                        },
                        success: function(msg){
                            console.debug('delete user: ' + userId);
                            console.debug(msg);
                            csrfName = msg.csrf.{{csrf.keys.name}};
                            csrfValue = msg.csrf.{{csrf.keys.value}};
                            UIkit.notification({
                                message: 'User deleted.',
                                status: 'success',
                                pos: 'top-center',
                                timeout: 2000
                            });
                        },
                        error: function(xhr, status, error) {
                            // var err = eval("(" + xhr.responseText + ")");
                            // alert(err.Message);
                            UIkit.notification({
                                message: xhr.statusText,
                                status: 'danger',
                                pos: 'top-center',
                                timeout: 2000
                            });
                        },
                    });
                });
                rows.remove().draw();
            });

            $("#add_user").on('click', function () {
                $.ajax({
                    type: "POST",
                    async: false,
                    url: "{{ path_for('admin.api.user.post') }}",
                    data: {
                        '{{csrf.keys.name}}': csrfName,
                        '{{csrf.keys.value}}': csrfValue,
                        'email': $('#email').val(),
                        'password': $('#password').val(),
                        'active': $('#active').prop("checked"),
                        'privileged': $('#privileged').prop("checked"),
                        // 'create_at': $('').val(),
                    },
                    success: function(msg){
                        UIkit.notification({
                            message: 'User added.',
                            status: 'success',
                            pos: 'top-center',
                            timeout: 2000
                        });
                    },
                    error: function(xhr, status, error) {
                        // var err = eval("(" + xhr.responseText + ")");
                        // alert(err.Message);
                        UIkit.notification({
                            message: xhr.statusText,
                            status: 'danger',
                            pos: 'top-center',
                            timeout: 2000
                        });
                    }
                });
                table.draw();
                UIkit.modal('#add_user_modal').hide();
            });
            $('#search').on( 'keyup', function () {
                table.search( this.value ).draw();
                console.debug(this.value)
            });
            $('#next').on( 'click', function () {
                table.page( 'next' ).draw( 'page' );
            } );

            $('#previous').on( 'click', function () {
                table.page( 'previous' ).draw( 'page' );
            } );
            $('#users').on( 'order.dt', function () {
                changeIcons();
            } );
            function changeIcons() {
                $('th').each(function () {
                    let children = $(this).children('.uk-icon');
                    if ($(this).hasClass('sorting_asc')){
                        UIkit.icon($(this).children('span'),{
                            'icon': 'triangle-up'
                        });
                    } else if ($(this).hasClass('sorting_desc')){
                        UIkit.icon($(this).children('span'),{
                            'icon': 'triangle-down'
                        });
                    } else if ($(this).hasClass('sorting')){
                        UIkit.icon($(this).children('span'),{
                            'icon': 'minus'
                        });
                    }
                })
            }
            function getUnique(arr, comp) {
                return arr
                    .map(e => e[comp])
                    .map((e, i, final) => final.indexOf(e) === i && i)
                    .filter(e => arr[e]).map(e => arr[e]);
            }

            $('table.dataTable thead th,table.dataTable tfoot th')
                .append('<span></span>');

            $('#edit').click(function () {
                let data = table.rows( { selected: true } ).data()[0];
                let email = data.email;
                let active = data.active;
                let privileged = data.privileged;
                $('#edit_email').val(email)
                $('#password').val('')
                $('#edit_active').prop('checked', getBoolean(active));
                $('#edit_privileged').prop('checked', getBoolean(privileged));
                UIkit.modal('#edit_user_modal').show();
            });

            $("#edit_user").on('click', function () {
                let data = table.rows( { selected: true } ).data()[0];
                $.ajax({
                    type: "PUT",
                    async: false,
                    url: "{{ path_for('admin.api.user.put',{'id': ''}) }}"+data.id,
                    data: {

                        '{{csrf.keys.name}}': csrfName,
                        '{{csrf.keys.value}}': csrfValue,
                        'email': $('#edit_email').val(),
                        'password': $('#edit_password').val(),
                        'active': $('#edit_active').prop("checked"),
                        'privileged': $('#edit_privileged').prop("checked"),
                    },
                    success: function(msg){
                        UIkit.notification({
                            message: 'User updated.',
                            status: 'success',
                            pos: 'top-center',
                            timeout: 2000
                        });
                    },
                    error: function(xhr, status, error) {
                        // var err = eval("(" + xhr.responseText + ")");
                        // alert(err.Message);
                        UIkit.notification({
                            message: xhr.statusText,
                            status: 'danger',
                            pos: 'top-center',
                            timeout: 2000
                        });
                    }
                });
                table.draw();

                UIkit.modal('#edit_user_modal').hide();
            });
            table.on( 'draw', function () {
                $('#edit').prop("disabled", true);
                $('#delete_row').prop("disabled", true);
            } );
            function getBoolean(value){
                switch(value){
                    case true:
                    case "true":
                    case 1:
                    case "1":
                    case "on":
                    case "yes":
                        return true;
                    default:
                        return false;
                }
            }
        } );
    </script>
{% endblock %}


